All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
3 # This program is licensed under the GNU GPL version 2 or later.
4 # (c) Richard "RichiH" Hartmann <richih@debian.org>, 2011-2015
5 # For details, see LICENSE. To submit patches, you have to agree to
6 # license your code under the GNU GPL version 2 or later.
8 # While the following is not legally binding, the author would like to
9 # explain the choice of GPLv2+ over GPLv3+.
10 # The author prefers GPLv3+ over GPLv2+ but feels it's better to maintain
11 # full compatibility's with Git. In case Git ever changes its licensing terms,
12 # which is admittedly extremely unlikely to the point of being impossible,
13 # this software will most likely follow suit.
15 # This should always be the first line of code to facilitate debugging
16 [ -n "$VCSH_DEBUG" ] && set -vx
19 # If '.git-HEAD' is appended to the version, you are seeing an unreleased
20 # version of vcsh; the master branch is supposed to be clean at all times
21 # so you can most likely just use it nonetheless
25 # Ensure all files created are accessible only to the current user.
29 echo "$SELF: fatal: $1" >&2
34 # We need to run getops as soon as possible so we catch -d and other
35 # options that will modify our behaviour.
36 # Commands are handled at the end of this script.
37 while getopts "c:dv" flag; do
38 if [ x"$1" = x'-d' ] || [ x"$1" = x'--debug' ]; then
43 elif [ x"$1" = x'-v' ]; then
45 echo "verbose mode on"
47 elif [ x"$1" = x'-c' ]; then
48 VCSH_OPTION_CONFIG=$OPTARG
54 # Source file even if it's in $PWD and does not have any slashes in it
62 # Read configuration and set defaults if anything's not set
63 [ -n "$VCSH_DEBUG" ] && set -vx
64 : ${XDG_CONFIG_HOME:="$HOME/.config"}
66 # Read configuration files if there are any
67 [ -r "/etc/vcsh/config" ] && . "/etc/vcsh/config"
68 [ -r "$XDG_CONFIG_HOME/vcsh/config" ] && . "$XDG_CONFIG_HOME/vcsh/config"
69 if [ -n "$VCSH_OPTION_CONFIG" ]; then
70 # Source $VCSH_OPTION_CONFIG if it can be read and is in $PWD of $PATH
71 if [ -r "$VCSH_OPTION_CONFIG" ]; then
72 source_all "$VCSH_OPTION_CONFIG"
74 fatal "Can not read configuration file '$VCSH_OPTION_CONFIG'" 1
77 [ -n "$VCSH_DEBUG" ] && set -vx
80 : ${VCSH_REPO_D:="$XDG_CONFIG_HOME/vcsh/repo.d"}
81 : ${VCSH_HOOK_D:="$XDG_CONFIG_HOME/vcsh/hooks-enabled"}
82 : ${VCSH_OVERLAY_D:="$XDG_CONFIG_HOME/vcsh/overlays-enabled"}
83 : ${VCSH_BASE:="$HOME"}
84 : ${VCSH_GITIGNORE:=exact}
85 : ${VCSH_GITATTRIBUTES:=none}
86 : ${VCSH_WORKTREE:=absolute}
88 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
89 fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
92 if [ ! "x$VCSH_WORKTREE" = 'xabsolute' ] && [ ! "x$VCSH_WORKTREE" = 'xrelative' ]; then
93 fatal "'\$VCSH_WORKTREE' must equal 'absolute', or 'relative'" 1
98 echo "usage: $SELF <options> <command>
101 -c <file> Source file
103 -v Enable verbose mode
106 clone [-b <branch>] \\
108 [<repo>] Clone from an existing repository
109 commit Commit in all repositories
110 delete <repo> Delete an existing repository
111 enter <repo> Enter repository; spawn new instance of \$SHELL
114 <git command> Execute a command for every repository
115 help Display this help text
116 init <repo> Initialize a new repository
117 list List all repositories
119 [<repo>] List all files tracked all or one repositories
122 [<repo>] List all files not tracked by all or one repositories
123 pull Pull from all vcsh remotes
124 push Push to vcsh remotes
126 <newname> Rename repository
128 <command> Use this repository
130 [--terse] [<repo>] Show statuses of all/one vcsh repositories
131 upgrade <repo> Upgrade repository to currently recommended settings
132 version Print version information
133 which <substring> Find substring in name of any tracked file
135 <repo> Write .gitignore.d/<repo> via git ls-files
137 <repo> <git command> Shortcut to run git commands directly
138 <repo> Shortcut to enter repository" >&2
142 [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $@"
146 if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
150 echo "$SELF: error: $1" >&2
154 echo "$SELF: info: $1"
160 git remote add origin "$GIT_REMOTE"
161 git checkout -b "$VCSH_BRANCH" || return $?
162 git config branch."$VCSH_BRANCH".remote origin
163 git config branch."$VCSH_BRANCH".merge refs/heads/"$VCSH_BRANCH"
164 if [ $(git ls-remote origin "$VCSH_BRANCH" 2> /dev/null | wc -l ) -lt 1 ]; then
165 info "remote is empty, not merging anything.
166 You should add files to your new repository."
169 GIT_VERSION_MAJOR=$(git --version | sed -n 's/.* \([0-9]\)\..*/\1/p' )
170 if [ 1 -lt "$GIT_VERSION_MAJOR" ];then
171 git fetch origin "$VCSH_BRANCH"
176 git ls-tree -r --name-only origin/"$VCSH_BRANCH" | (while read object; do
178 error "'$object' exists." &&
181 [ x"$VCSH_CONFLICT" = x'1' ]) &&
182 fatal "will stop after fetching and not try to merge!
183 Once this situation has been resolved, run 'vcsh $VCSH_REPO_NAME pull' to finish cloning." 17
184 git -c merge.ff=true merge origin/"$VCSH_BRANCH"
188 hook post-clone-retired
193 for VCSH_REPO_NAME in $(list); do
194 echo "$VCSH_REPO_NAME: "
195 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
197 git commit --untracked-files=no --quiet $@
198 VCSH_COMMAND_RETURN_CODE=$?
205 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
207 info "This operation WILL DESTROY DATA!"
208 files=$(git ls-files)
209 echo "These files will be deleted:
213 AGAIN, THIS WILL DELETE YOUR DATA!
214 To continue, type 'Yes, do as I say'"
216 [ "x$answer" = 'xYes, do as I say' ] || exit 16
217 for file in $files; do
218 rm -f $file || info "could not delete '$file', continuing with deletion"
220 rm -rf "$GIT_DIR" || error "could not delete '$GIT_DIR'"
233 # We default to prefixing `git` to all commands passed to foreach, but
234 # allow running in general context with -g
236 while getopts "g" flag; do
237 if [ x"$1" = x'-g' ]; then
242 for VCSH_REPO_NAME in $(list); do
243 echo "$VCSH_REPO_NAME:"
244 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
252 [ -d "$GIT_DIR" ] || fatal "no repository found for '$VCSH_REPO_NAME'" 12
256 for hook in "$VCSH_HOOK_D/$1"* "$VCSH_HOOK_D/$VCSH_REPO_NAME.$1"*; do
257 [ -x "$hook" ] || continue
258 verbose "executing '$hook'"
265 [ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
266 mkdir -p "$VCSH_BASE" || fatal "could not create '$VCSH_BASE'" 50
267 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
268 git init --shared=false
274 for repo in "$VCSH_REPO_D"/*.git; do
275 [ -d "$repo" ] && [ -r "$repo" ] && echo "$(basename "$repo" .git)"
280 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
285 VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
286 if [ -n "$VCSH_REPO_NAME" ]; then
287 get_files | list_tracked_helper
289 for VCSH_REPO_NAME in $(list); do
291 done | list_tracked_helper
295 list_tracked_helper() {
296 sed "s,^,$(printf '%s\n' "$VCSH_BASE/" | sed 's/[,\&]/\\&/g')," | sort -u
304 command -v 'comm' >/dev/null 2>&1 || fatal "Could not find 'comm'"
306 temp_file_others=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal 'Could not create temp file'
307 temp_file_untracked=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal 'Could not create temp file'
308 temp_file_untracked_copy=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal 'Could not create temp file'
310 # Hack in support for `vcsh list-untracked -r`...
311 exclude_standard_opt='--exclude-standard'
312 directory_opt="--directory"
314 while getopts "ar" flag; do
315 if [ x"$1" = x'-a' ]; then
316 unset exclude_standard_opt
317 elif [ x"$1" = x'-r' ]; then
322 # ...and parse for a potential parameter afterwards. As we shifted things out of $* in during getops, we need to look at $1
323 VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
325 if [ -n "$VCSH_REPO_NAME" ]; then
326 list_untracked_helper $VCSH_REPO_NAME
328 for VCSH_REPO_NAME in $(list); do
329 list_untracked_helper $VCSH_REPO_NAME
332 cat $temp_file_untracked
334 unset directory_opt directory_component
335 rm -f $temp_file_others $temp_file_untracked $temp_file_untracked_copy || fatal 'Could not delete temp files'
338 list_untracked_helper() {
339 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
340 git ls-files --others $exclude_standard_opt "$directory_opt" | (
343 directory_component=${line%%/*}
344 [ -d "$directory_component" ] && printf '%s/\n' "$directory_component"
346 ) | sort -u > $temp_file_others
347 if [ -z "$ran_once" ]; then
349 cp $temp_file_others $temp_file_untracked || fatal 'Could not copy temp file'
351 cp $temp_file_untracked $temp_file_untracked_copy || fatal 'Could not copy temp file'
352 comm -12 $temp_file_others $temp_file_untracked_copy > $temp_file_untracked
357 for VCSH_REPO_NAME in $(list); do
358 printf '%s: ' "$VCSH_REPO_NAME"
359 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
362 VCSH_COMMAND_RETURN_CODE=$?
370 for VCSH_REPO_NAME in $(list); do
371 printf '%s: ' "$VCSH_REPO_NAME"
372 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
375 VCSH_COMMAND_RETURN_CODE=$?
387 [ -d "$GIT_DIR_NEW" ] && fatal "'$GIT_DIR_NEW' exists" 54
388 mv -f "$GIT_DIR" "$GIT_DIR_NEW" || fatal "Could not mv '$GIT_DIR' '$GIT_DIR_NEW'" 52
390 # Now that the repository has been renamed, we need to fix up its configuration
391 # Overwrite old name..
393 VCSH_REPO_NAME=$VCSH_REPO_NAME_NEW
394 # ..and clobber all old configuration
402 VCSH_COMMAND_RETURN_CODE=$?
408 COLORING="-c color.status=always"
410 if [ -n "$VCSH_REPO_NAME" ]; then
411 status_helper $VCSH_REPO_NAME
413 for VCSH_REPO_NAME in $(list); do
414 STATUS=$(status_helper $VCSH_REPO_NAME "$COLORING")
415 [ -n "$STATUS" -o -z "$VCSH_STATUS_TERSE" ] && echo "$VCSH_REPO_NAME:"
416 [ -n "$STATUS" ] && echo "$STATUS"
417 [ -z "$VCSH_STATUS_TERSE" ] && echo
423 GIT_DIR=$VCSH_REPO_D/$1.git; export GIT_DIR
426 remote_tracking_branch=$(git rev-parse --abbrev-ref --symbolic-full-name @{u} 2> /dev/null) && {
427 commits_behind=$(git log ..${remote_tracking_branch} --oneline | wc -l)
428 commits_ahead=$(git log ${remote_tracking_branch}.. --oneline | wc -l)
429 [ ${commits_behind} -ne 0 ] && echo "Behind $remote_tracking_branch by $commits_behind commits"
430 [ ${commits_ahead} -ne 0 ] && echo "Ahead of $remote_tracking_branch by $commits_ahead commits"
432 git ${VCSH_GIT_OPTIONS} status --short --untracked-files='no'
433 VCSH_COMMAND_RETURN_CODE=$?
438 # fake-bare repositories are not bare, actually. Set this to false
439 # because otherwise Git complains "fatal: core.bare and core.worktree
441 git config core.bare false
442 # core.worktree may be absolute or relative to $GIT_DIR, depending on
444 if [ ! "x$VCSH_WORKTREE" = 'xabsolute' ]; then
445 git config core.worktree "$(cd "$GIT_DIR" && GIT_WORK_TREE=$VCSH_BASE git rev-parse --show-cdup)"
446 elif [ ! "x$VCSH_WORKTREE" = 'xrelative' ]; then
447 git config core.worktree "$VCSH_BASE"
449 [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
450 [ ! "x$VCSH_GITATTRIBUTES" = 'xnone' ] && git config core.attributesfile ".gitattributes.d/$VCSH_REPO_NAME"
451 git config vcsh.vcsh 'true'
453 [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME"
454 [ -e "$VCSH_BASE/.gitattributes.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitattributes.d/$VCSH_REPO_NAME"
460 VCSH_DIRECTORY=$VCSH_REPO_NAME; export VCSH_DIRECTORY
464 output=$(for VCSH_REPO_NAME in $(list); do
465 get_files | grep -- "$VCSH_COMMAND_PARAMETER" | sed "s/^/$VCSH_REPO_NAME: /"
467 if [ -z "$output" ]; then
468 fatal "'$VCSH_COMMAND_PARAMETER' does not exist" 1
475 # Don't do anything if the user does not want to write gitignore
476 if [ "x$VCSH_GITIGNORE" = 'xnone' ]; then
477 info "Not writing gitignore as '\$VCSH_GITIGNORE' is set to 'none'"
482 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
483 local GIT_VERSION="$(git --version)"
484 local GIT_VERSION_MAJOR=$(echo $GIT_VERSION | sed -n 's/.* \([0-9]\)\..*/\1/p')
485 local GIT_VERSION_MINOR=$(echo $GIT_VERSION | sed -n 's/.* \([0-9]\)\.\([0-9]\)\..*/\2/p')
488 gitignores=$(for file in $(git ls-files); do
489 if [ $GIT_VERSION_MAJOR -ge 2 -a $GIT_VERSION_MINOR -ge 7 ]; then
493 echo "$file"; new=${file%/*}
494 [ x"$file" = x"$new" ] && break
500 # Contrary to GNU mktemp, mktemp on BSD/OSX requires a template for temp files
501 # Using a template makes GNU mktemp default to $PWD and not #TMPDIR for tempfile location
502 # To make every OS happy, set full path explicitly
503 tempfile=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal "could not create tempfile: '${tempfile}'" 51
505 echo '*' > "$tempfile" || fatal "could not write to '$tempfile'" 57
506 for gitignore in $gitignores; do
507 echo "$gitignore" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
508 if [ "x$VCSH_GITIGNORE" = 'xrecursive' ] && [ -d "$gitignore" ]; then
509 { echo "$gitignore/*" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
513 if diff -N "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
514 rm -f "$tempfile" || error "could not delete '$tempfile'"
517 if [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ]; then
518 info "'$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'"
519 mv -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak" ||
520 fatal "could not move '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
522 mv -f "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ||
523 fatal "could not move '$tempfile' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME'" 53
528 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
529 fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
532 VCSH_COMMAND=$1; export VCSH_COMMAND
534 case $VCSH_COMMAND in
535 clon|clo|cl) VCSH_COMMAND=clone;;
536 commi|comm|com|co) VCSH_COMMAND=commit;;
537 delet|dele|del|de) VCSH_COMMAND=delete;;
538 ente|ent|en) VCSH_COMMAND=enter;;
539 hel|he) VCSH_COMMAND=help;;
540 ini|in) VCSH_COMMAND=init;;
541 pul) VCSH_COMMAND=pull;;
542 pus) VCSH_COMMAND=push;;
543 renam|rena|ren|re) VCSH_COMMAND=rename;;
544 ru) VCSH_COMMAND=run;;
545 statu|stat|sta|st) VCSH_COMMAND=status;;
546 upgrad|upgra|upgr|up) VCSH_COMMAND=upgrade;;
547 versio|versi|vers|ver|ve) VCSH_COMMAND=version;;
548 which|whi|wh) VCSH_COMMAND=which;;
549 write|writ|wri|wr) VCSH_COMMAND=write-gitignore;;
552 if [ x"$VCSH_COMMAND" = x'clone' ]; then
554 if [ "$2" = -b ]; then
559 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a remote" 1
561 [ -n "$VCSH_BRANCH" ] || if [ "$3" = -b ]; then
568 [ -z "$VCSH_BRANCH" ] && [ "$4" = -b ] && VCSH_BRANCH=$5
570 VCSH_REPO_NAME=$(basename "${GIT_REMOTE#*:}" .git)
572 [ -z "$VCSH_REPO_NAME" ] && fatal "$VCSH_COMMAND: could not determine repository name" 1
573 export VCSH_REPO_NAME
574 [ -n "$VCSH_BRANCH" ] || VCSH_BRANCH=master
575 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
576 elif [ "$VCSH_COMMAND" = 'version' ]; then
577 echo "$SELF $VERSION"
580 elif [ x"$VCSH_COMMAND" = x'which' ]; then
581 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a filename" 1
582 [ -n "$3" ] && fatal "$VCSH_COMMAND: too many parameters" 1
583 VCSH_COMMAND_PARAMETER=$2; export VCSH_COMMAND_PARAMETER
584 elif [ x"$VCSH_COMMAND" = x'delete' ] ||
585 [ x"$VCSH_COMMAND" = x'enter' ] ||
586 [ x"$VCSH_COMMAND" = x'init' ] ||
587 [ x"$VCSH_COMMAND" = x'list-tracked-by' ] ||
588 [ x"$VCSH_COMMAND" = x'rename' ] ||
589 [ x"$VCSH_COMMAND" = x'run' ] ||
590 [ x"$VCSH_COMMAND" = x'upgrade' ] ||
591 [ x"$VCSH_COMMAND" = x'write-gitignore' ]; then
592 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify repository to work on" 1
593 [ x"$VCSH_COMMAND" = x'rename' ] && [ -z "$3" ] && fatal "$VCSH_COMMAND: please specify a target name" 1
594 [ x"$VCSH_COMMAND" = x'run' ] && [ -z "$3" ] && fatal "$VCSH_COMMAND: please specify a command" 1
595 VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
596 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
597 [ x"$VCSH_COMMAND" = x'rename' ] && { VCSH_REPO_NAME_NEW=$3; export VCSH_REPO_NAME_NEW;
598 GIT_DIR_NEW=$VCSH_REPO_D/$VCSH_REPO_NAME_NEW.git; export GIT_DIR_NEW; }
599 [ x"$VCSH_COMMAND" = x'run' ] && shift 2
600 elif [ x"$VCSH_COMMAND" = x'foreach' ]; then
601 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a command" 1
603 elif [ x"$VCSH_COMMAND" = x'commit' ] ||
604 [ x"$VCSH_COMMAND" = x'list' ] ||
605 [ x"$VCSH_COMMAND" = x'list-tracked' ] ||
606 [ x"$VCSH_COMMAND" = x'list-untracked' ] ||
607 [ x"$VCSH_COMMAND" = x'pull' ] ||
608 [ x"$VCSH_COMMAND" = x'push' ]; then
610 elif [ x"$VCSH_COMMAND" = x'status' ]; then
611 if [ x"$2" = x'--terse' ]; then
612 VCSH_STATUS_TERSE=1; export VCSH_STATUS_TERSE
615 VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
616 elif [ -n "$2" ]; then
617 VCSH_COMMAND='run'; export VCSH_COMMAND
618 VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
619 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
620 [ -d "$GIT_DIR" ] || { help; exit 1; }
623 elif [ -n "$VCSH_COMMAND" ]; then
624 VCSH_COMMAND='enter'; export VCSH_COMMAND
625 VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
626 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
627 [ -d "$GIT_DIR" ] || { help; exit 1; }
629 # $1 is empty, or 'help'
633 # Did we receive a directory instead of a name?
634 # Mangle the input to fit normal operation.
635 if echo "$VCSH_REPO_NAME" | grep -q '/'; then
636 GIT_DIR=$VCSH_REPO_NAME; export GIT_DIR
637 VCSH_REPO_NAME=$(basename "$VCSH_REPO_NAME" .git); export VCSH_REPO_NAME
642 if [ ! -d "$check_directory" ]; then
643 if [ -e "$check_directory" ]; then
644 fatal "'$check_directory' exists but is not a directory" 13
646 verbose "attempting to create '$check_directory'"
647 mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
652 check_dir "$VCSH_REPO_D"
653 [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && check_dir "$VCSH_BASE/.gitignore.d"
654 [ ! "x$VCSH_GITATTRIBUTES" = 'xnone' ] && check_dir "$VCSH_BASE/.gitattributes.d"
656 verbose "$VCSH_COMMAND begin"
657 VCSH_COMMAND=$(echo "$VCSH_COMMAND" | sed 's/-/_/g'); export VCSH_COMMAND
659 # Source repo-specific configuration file
660 [ -r "$XDG_CONFIG_HOME/vcsh/config.d/$VCSH_REPO_NAME" ] && . "$XDG_CONFIG_HOME/vcsh/config.d/$VCSH_REPO_NAME"
662 # source overlay functions
663 for overlay in "$VCSH_OVERLAY_D/$VCSH_COMMAND"* "$VCSH_OVERLAY_D/$VCSH_REPO_NAME.$VCSH_COMMAND"*; do
664 [ -r "$overlay" ] || continue
665 info "sourcing '$overlay'"
672 verbose "$VCSH_COMMAND end, exiting"
673 exit $VCSH_COMMAND_RETURN_CODE